# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# Action navigation
#  
# Point d'entree pour la gestion des navigations web
#       
###########################################################################

""" Action de gestion des navigations web sur un amon """
from twisted.python import log
from ead2.backend.lib.action import * # import des actions et des types
from ead2.backend.actions.tools import get_request 
from ead2.backend.actions.amon.amon_tools import get_visit_menu, get_refused_menu, get_filters_menu, get_access_menu
from ead2.lib.libead import uni
import commands

used_templates = ['main']

class NavigationWeb(Action):
    """ interface de gestion des navigations (visite, filtrage, acces) """
    user_description = Dict(default={}, doc="description de l'éxécutant", keys=['ip', 'name'])
    name = 'navigation'
    libelle = 'Visites'
    description = 'Observatoire des Navigations Web'
    category = 'Outils'
    request = Dict(default={}, doc="arguments de la requete en cour cote frontend", keys=['server', 'action'])

    def execute(self):
        params, self.server_nb = get_request(self.request)
        result = {'titre':self.description}
        result['sstitre'] = ''
        result['message'] = ['Dans cette section vous avez la possibilité de :', 
                '- consulter les sites visités depuis les 15 derniers jours par poste, utilisateur ou ip',
                "- consulter les tentatives d'accès aux sites interdits"  ]
        result['menus'] = self._get_menus()
        d = {'template':'amon_navigation', 'data':{'content':result, 'templates':used_templates}}
        return 0, uni(str(d))

    def _get_menus(self):
        return get_visit_menu(self.server_nb), get_refused_menu(self.server_nb)

