# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# Action navigation_refused
#  
# Affiche les tentatives d'acces aux sites refuses
#       
###########################################################################

""" Action de contrôle des sites refusés sur un amon """
from twisted.python import log
from ead2.backend.lib.action import * # import des actions et des types
from ead2.backend.actions.tools import get_request
from ead2.backend.actions.amon.amon_tools import get_return_btn
from ead2.lib.libead import uni
from ead2.backend.config.config import SCRIPT_DIR
import commands, urllib
from os.path import join

class NavigationRefused(Action):
    """ interface d'affichage des sites refusés """
    user_description = Dict(default={}, doc="description de l'éxécutant", keys=['ip', 'name'])
    name = 'navigation_refused'
    libelle = 'Sites refusés'
    description = 'Observation des sites refusés'
    category = None
    request = Dict(default={}, doc="arguments de la requete en cour cote frontend", keys=['server', 'action'])

    def execute(self):
        params, self.server_nb = get_request(self.request)
        result = {'titre':self.description}
        result['message'] = [self._get_logs()]
        result['menus'] = self._get_menus()
        result['retour'] = get_return_btn(self.server_nb)
        d = {'template':'amon_navigation_refused', 'data':{'content':result}}
        return 0, uni(urllib.quote(str(d)))

    def _get_menus(self):
        return []

    def _get_logs(self):
        """ renvoit les données des logs de dansguardian """
        script = join(SCRIPT_DIR, 'dans_log.py')
        a,b = commands.getstatusoutput(script)
        if a:
            b = "<p> Erreur lors de la récupération des logs</p>"
        return b
