# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# Action gestion_account_suppr
#  
# Supprime des comptes utilisateurs
#       
###########################################################################

""" Actions permettant de gérer les groupes """
from twisted.python import log
from ead2.backend.lib.action import * # import des actions et des types
from ead2.backend.actions.tools import get_request, make_form_link, make_confirm_link
from ead2.backend.config.config import SCRIPT_DIR
from ead2.lib.libead import uni
import commands
from os.path import join
from horus import backend as horus # import des actions (get_groups, mod_user, inscription ... )
from ead2.backend.actions.horus import gestion_tools as G

titre='Gestion des comptes utilisateurs'
class GestionAccountDelete(Action):
    """ gere la suppression de partage """
    user_description = Dict(default={}, doc="description de l'éxécutant", keys=['ip', 'name'])
    name = 'gestion_account_suppr'
    libelle = "suppression de compte"
    category = None
    description = 'supprimer un compte'
    request = Dict(default={}, doc="arguments de la requete en cour cote frontend", keys=['server', 'action'])
    form_result = Dict(default={}, doc="Retour de formulaire en Json", keys=['account'])
    
    def execute(self):
        """ renvoit les données pour l'affichage """
        params, server_nb = get_request(self.request)
        menu = [{"href":"", "title":'', 'icone':'/image/del_account.gif', 'libelle':"Suppression de compte"}] 
        sstitre = self.description
        result = {'sstitre':sstitre,'titre':titre, 'menus':menu}
        result['retour']  = G.get_return_btn(server_nb)
        code= None
        nom = None
        if self.form_result!={}:
            try: 
                code, nom = self.del_account(self.form_result)
            except:
                code = 1
            self.form_result = {}
        if code is not None:
            if code:
                retour = "Erreur lors de la suppression du compte"
            else:
                retour = "Le compte %s a bien été supprimé"%nom
            result['retour_msg'] = retour
        else:
            result['retour_msg'] = ''
        result['formulaires'] = [{'name':'account', 'formulaire':self._get_form()}]
        result['validate'] = self._get_valid_btn(server_nb)
        d = {'template':'gestion_form', 'data':{'content':result, 'templates':['gestion']}}
        return 0, uni(str(d))

    def _get_form(self):
        form = []
        tag1 = {'_type':'choice', 'name':'account_name', 'default_value': '', 'values':horus.get_workstations(), 'libelle':"Nom de la station de travail"}
        form = [tag1]
        return form

    def del_account(self, dico):
        """ supprimer un compte """
        if dico.has_key('account'):
            name = None
            params = dico['account']
            for param in params:
                nom = param['name']
                value = param['value']
                if nom == 'account_name':
                    name = value
            if name is not None:
                d = horus.del_workstation(name)
                if d:
                    return 0, name
        return 1, None 

    def _get_valid_btn(self, server_nb):
        """ renvoit la description du bouton valider """
        validate = {}
        href = make_form_link(server_nb, self.name, False, ['account'])
        validate['href'] = make_confirm_link("Êtes-vous sûr de vouloir supprimer ce compte?", href)
#        validate['href'] = "javascript:formValidForm('%s','%s',['account'])"%(server_nb, self.name)
        validate['icone'] = "/image/ok.gif"
        validate['libelle'] = "Valider"
        validate['title'] = "Supprimer ce compte"
        return validate

