# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# Action Status 
#  
# Page d'accueil d'un serveur de commande
#       
###########################################################################

""" Actions affichant les différents statut du serveur """

from twisted.python import log
from ead2.backend.lib.action import *
from ead2.backend.actions.tools import get_request, make_js_link
from ead2.lib.libead import uni
import commands,xmlrpclib, socket
from os.path import isfile, join
from os import listdir
from ead2.backend.config.config import BACULA_TEMP_DIR, MAJ_TEMP_DIR, AGENT_PORT, AGENT_PROTOCOL, module
from ead2.config.config import ip_locale
from ead2.backend.config.filenames import bacula, maj,index, rapport_extraction
from ead2.frontend.web.config import ACTION_SOCKET_TIMEOUT

from zephir.monitor.agentmanager import config as config_agent#id_serveur

save_report_file = bacula['rapport'] #join(BACULA_TEMP_DIR, 'rapport-bacula.txt')
update_report_file = maj['rapport']  #join(MAJ_TEMP_DIR, 'rapport-maj.txt')
blacklist_report_file = index['blacklist']
extraction_report_file = rapport_extraction

tmp = listdir('/etc/init.d/')
if isfile('/etc/sysconfig/eole/services'):
    tmp = file('/etc/sysconfig/eole/services', 'r')
    tmp = [i.strip() for i in tmp.readlines()]

as_save_module = ['horus']
as_blacklist_module = ['amon']
as_extract_module = ['scribe']

list_services = [nom_serv for nom_serv in tmp]# if not nom_serv.endswith('~')]

class Status(Action):
    """ Action de presentation du statut du serveur 
        page d'acceuil du serveur
    """
    user_description = Dict(default={}, doc="description de l'éxécutant", keys=['ip', 'name'])
    name = 'main_status'
    libelle = 'Accueil'
    category = ""#'Accueil'
    description = "Le statut actuel de votre serveur"
    request = Dict(default={}, doc="arguments de la requete en cour cote frontend", 
                                keys=['server', 'action', 'aff_maj', 'aff_save', 'aff_blacklist', 'aff_extract'])


    def execute(self):
        if self.request is not {}:
            params, self.server_nb = get_request(self.request)
        ## si on appelle l'affichage d'un rapport, on renvoie un fragment de page
        if params.has_key('aff_maj'):
            if params['aff_maj'][0] == 'true':
                datas = self.get_update_report(True)
            else:
                datas = {'report':{'btn':self._get_update_btn(False), 'texte':''}}
            return self.frag(datas)
        if params.has_key('aff_extract'):
            if params['aff_extract'][0] == 'true':
                datas = self.get_extract_report(True)
            else:
                datas = {'report':{'btn':self._get_extract_btn(False), 'texte':''}}
            return self.frag(datas)
        if params.has_key('aff_save'):
            if params['aff_save'][0] == 'true':
                datas = self.get_save_report(True)
            else:
                datas = {'report':{'btn':self._get_save_btn(False), 'texte':''}}
            return self.frag(datas)
        if params.has_key('aff_blacklist'):
            if params['aff_blacklist'][0] == 'true':
                datas = self.get_blacklist_report(True)
            else:
                datas = {'report':{'btn':self._get_blacklist_btn(False), 'texte':''}}
            return self.frag(datas)
        ## page complète
        result = {}
        result.update(self.get_update_report())
        if module in as_extract_module:result.update(self.get_extract_report())
        if module in as_save_module:result.update(self.get_save_report())
        if module in as_blacklist_module:result.update(self.get_blacklist_report())
        result.update(self.get_services_status())
        d = {'template':'index', 'data':{'content':result, 'templates':['main']}}
        return 0, uni(str(d))

    def frag(self, datas):
        result = datas
        d = {'template':'index', 'data':{'content':result, 'templates':['main']}}
        return 0, uni(str(d))

    def _get_save_btn(self, aff=False):
        if aff:
            return {'href':make_js_link(self.server_nb, self.name, aff_save='false', balise="div_save_container"),
                    'icone':'/image/reduce.jpg', 'libelle':'Masquer le rapport', 
                    'title':"Masquer le rapport de sauvegarde", '_class':'btn'}
        else:
            return {'href':make_js_link(self.server_nb, self.name, aff_save='true', balise="div_save_container"),
                    'icone':'/image/increase.jpg', 'libelle':'Afficher le rapport', 
                    'title':"Afficher le rapport de sauvegarde", '_class':'btn'}

    def _get_update_btn(self, aff=False):
        if aff:
            return {'href':make_js_link(self.server_nb, self.name, aff_maj='false', balise="div_maj_container"),
                    'icone':'/image/reduce.jpg', 'libelle':'Masquer le rapport', 
                    'title':'Masquer le rapport de mise à jour', '_class':'btn'}
        else:
            return {'href':make_js_link(self.server_nb, self.name, aff_maj='true', balise="div_maj_container"),
                    'icone':'/image/increase.jpg', 'libelle':'Afficher le rapport',
                    'title':'Afficher le rapport de mise à jour', '_class':'btn'}

    def _get_blacklist_btn(self, aff=False):
        if aff:
            return {'href':make_js_link(self.server_nb, self.name, aff_blacklist='false', balise="div_blacklist_container"),
                    'icone':'/image/reduce.jpg', 'libelle':'Masquer le rapport',
                    'title':'Masquer le rapport', "_class":"btn"}
        else:
            return {'href':make_js_link(self.server_nb, self.name, aff_blacklist='true', balise="div_blacklist_container"),
                    'icone':'/image/increase.jpg', 'libelle':'Afficher le rapport',
                    'title':'Afficher le rapport', "_class":"btn"}

    def _get_extract_btn(self, aff=False):
        if aff:
            return {'href':make_js_link(self.server_nb, self.name, aff_extract='false', balise="div_extract_container"),
                    'icone':'/image/reduce.jpg', 'libelle':'Masquer le rapport', 'title':'Masquer le rapport',
                    '_class':'btn'}
        else:
            return {'href':make_js_link(self.server_nb, self.name, aff_extract='true', balise="div_extract_container"),
                    'icone':'/image/increase.jpg', 'libelle':'Afficher le rapport', 'title':'Masquer le rapport', 
                    '_class':'btn'}

    def get_services_status(self):
        result = {}
        if AGENT_PORT is not None:
            serv = xmlrpclib.ServerProxy('%s://localhost:%s/xmlrpc/'%(AGENT_PROTOCOL,AGENT_PORT))
            try:
                socket.setdefaulttimeout(ACTION_SOCKET_TIMEOUT)
                result = serv.status_for_agents()
                _menu_services = serv.agents_menu()
            except:
                import traceback
                traceback.print_exc()
                result = {}
                _menu_services = {}
            menu_services = {}
            for key, items in _menu_services.items():
                cle = key.encode('utf-8')
                options = [[item[0].encode('utf-8'), item[1].encode('utf-8')]for item in items]
                main_status = 'OK'
                for item in options:
                    if result.has_key(item[0]):
                        datas={}
                        if result[item[0]].has_key('message'):
                            datas['message'] = result[item[0]]['message'].encode('utf-8')
                        datas['level'] = result[item[0]]['level'].encode('utf-8')
                        if datas['level'] == 'Warn':main_status = 'Warn'
                        elif datas['level'] != 'OK' : main_status = 'NO'
                        reload(config_agent)
                        url = '%s://%s:%s/agents/%s/%s/'%(AGENT_PROTOCOL, ip_locale, AGENT_PORT, config_agent.id_serveur, item[0])
                        datas['href'] = make_js_link(self.server_nb, 'help', agent=url)
                        item.append(datas)
                    else:
                        items.remove(item)
                menu_services[cle] = {'main_status':main_status, 'options':options}
            return dict(services=menu_services)
            # en attendant que ça soit dispo ...
            try: del(result['sentinelle'])
            except: pass
            for a, b in result.items():
                if b['message']:
                    b['message'] = b['message'].encode('utf-8')
                url = '%s://%s:%s/'%(AGENT_PROTOCOL, ip_locale, AGENT_PORT)
                b['href'] = make_js_link(self.server_nb, 'help', agent=url)
            return result
        else:
            for service in list_services:
                a = commands.getoutput('/etc/init.d/%s | grep -q status 2>/dev/null'%service)
                b = commands.getoutput('echo $?')
                if b == '0':
                    a, b = commands.getstatusoutput('/etc/init.d/%s status'%service)
                    if not a:
                        result[service] = {'level':'OK' }
                    else:
                        result[service] = {'level':'NO'}
            return dict(result)

    def get_save_report(self, aff=False):
        """ renvoit le rapport des dernières sauvegarde """
        if not isfile(save_report_file):
            return dict(sauvegarde={'title':"Sauvegarde",'texte': ["Dernière sauvegarde : ", 'Aucune sauvegarde'],
                          'btn':'', 'diode':''})
        else:
            a = file(save_report_file, 'r')
            if not aff:
                report = a.readlines()
                if len(report)>=1:report = report[0]
                report = ["Dernière sauvegarde : ", report]
                a.close()
                return dict(sauvegarde={'title':"Sauvegarde",'texte':report,'btn':self._get_save_btn(aff)})
            else:
                report = a.readlines()
                a.close()
                return dict(report={'btn':self._get_save_btn(aff), 'texte':report})
    
    def get_update_report(self, aff=False):
        """ renvoit le rapport des dernières mise à jour """
        if not isfile(update_report_file):
            return dict(maj={'title':"Mise à jour",'texte': ["Dernière mise à jour : ", 'Aucune mise à jour'],
                          'btn':'', 'diode':''})
        else:
            a = file(update_report_file, 'r')
            if not aff:
                ## la mise a jour a-t-elle reussie?
                if 'Mise à jour OK' in a.read():diode='OK'
                else:diode='No'
                a.seek(0)
                report = a.readlines()
                if len(report)>=1:report = report[0]
                report = ["Dernière mise à jour : ", report]
                a.close()
                return dict(maj={'title':"Mise à jour",'texte':report,'btn':self._get_update_btn(aff), 'diode':diode})
            else:
                report = a.readlines()
                a.close()
                return dict(report={'btn':self._get_update_btn(aff), 'texte':report})
    
    def get_extract_report(self, aff=False):
        """ renvoit le rapport de la dernière extraction """
        if not isfile(extraction_report_file):
            return dict(extract={'title':"Extraction",'texte': ["Dernière extraction : ", 'Aucune extraction'],
                          'btn':'', 'diode':''})
        else:
            a = file(extraction_report_file, 'r')
            if not aff:
                report = a.readlines()
                if len(report)>=1:report = report[0]
                report = ["Dernière extraction : ", report]
                a.close()
                return dict(extract={'title':"Extraction",'texte':report,'btn':self._get_extract_btn(aff)})
            else:
                report = a.readlines()
                a.close()
                return dict(report={'btn':self._get_extract_btn(aff), 'texte':report})

    def get_blacklist_report(self, aff=False):
        """ renvoit le rapport des dernières mis a jour de la blacklist """
        report = ["Aucune mise à jour de la liste de sites interdits n'a été effectuée"]
        if not isfile(blacklist_report_file):
            return dict(blacklist={'title':"Liste de sites interdits",'texte': ["Dernière Mise à jour de la liste de sites interdits : ", 'Aucune mise à jour'],
                          'btn':'', 'diode':''})
        else:
            a = file(blacklist_report_file, 'r')
            if not aff:
                report = a.readlines()
                if len(report)>=1:report = report[0]
                report = ["Dernière mise à jour : ", report]
                a.close()
                return dict(blacklist={'title':"Liste de sites interdits",'texte':report,'btn':self._get_blacklist_btn(aff)})
            else:
                report = a.readlines()
                a.close()
                return dict(report={'btn':self._get_blacklist_btn(aff), 'texte':report})
