#!/usr/bin/python
# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# Utilitaire pour exploiter les log de dansguardian
#  
#       
###########################################################################

"""
Utilitaire pour exploiter les log de dansguardian
licence GPL Eole
Joël Cuissinat 

%prog [options]

"""

__version__ = '%prog v0.1a'

###################
# modules importés
from sys import exit
from commands import getoutput
#####################

# fichier de log à traiter
fichier = "/var/log/dansguardian/access.log"


def parse_command_line():
    """
    Construit le parser d'options de la ligne de commande,
    parse la ligne de commande, et retourne les options
    """
    from optparse import OptionParser
    parser = OptionParser(__doc__, version = __version__)
    
    parser.add_option("-d", "--debut", dest="debut",
                      default="1",
                      help="debut",
                      metavar="debut")
		      
    parser.add_option("-f", "--fin", dest="fin",
                      default="-1",
                      help="fin",
                      metavar="fin")
    
    options, args = parser.parse_args()
    return options


if __name__ == "__main__":
    # parsing de la ligne de commande
    options = parse_command_line()
    if options.fin == "-1":
        options.fin = int(options.debut) + 24
    if int(options.debut) <= int(options.fin) :
        deb,fin=int(options.debut),int(options.fin)
    else:
        deb,fin=int(options.fin),int(options.debut)

    try:
        # un petit grep est plus rapide que de tout traiter :)
        resultat = getoutput ("grep \"*DENIED*\" "+fichier+" 2>/dev/null")
        lignes = resultat.split("\n")
        lignes.reverse()
    except:
        exit()


    nb_acces=0
    contenu=""
    
    for ligne in lignes:
	if ligne=="":
	    continue
        nb_acces+=1
	if nb_acces < deb :
            continue
	if nb_acces%2 == 0:
	    couleur="bgcolor=#FFFFCA"
        else:
	    couleur="bgcolor=#FFFFFF"
	tab=ligne.split(',')
	j1=tab[0][1:-1].split(" ")
	j2=j1[0].split(".")
	contenu+="<tr "+couleur+">"
	# date
	contenu+="<td>"+j2[2]+"."+j2[1]+"."+j2[0]+"</td>"
	# heure
	contenu+="<td>"+j1[1]+"</td>"
	# poste client
	contenu+="<td>"+tab[2][1:-1]+"</td>"
	# page accédée
	site = tab[3][1:-1]
	contenu+="<td><font size=-1><a href=\""+site+"\">"
	if len(site) < 55 :
            contenu += site
	else :
            contenu += site[0:50]+' [...]'
	contenu+="</a></font></td>"
	# utilisateur
	contenu+="<td>"+tab[1][1:-1]+"</td></tr>\n"
        if nb_acces == fin :
            break

    if contenu :
        if fin > len(lignes):
            finreelle = str(len(lignes))
        else:
            finreelle = str(fin)
        print "de "+str(deb)+" à "+finreelle+" sur "+str(len(lignes))
        print '<TABLE WIDTH="100%" ALIGN="CENTER" BORDER="0" CELLPADDING="3" CELLSPACING="0">'    
        print """<TR BGCOLOR="#DFDFFF" ALIGN="LEFT">
	<TD ALIGN="LEFT">Date</TD>
	<TD ALIGN="LEFT">Heure</TD>
	<TD ALIGN="LEFT">Poste client</TD>
	<TD ALIGN="LEFT">Page accédée</TD>
	<TD ALIGN="LEFT">Utilisateur</TD></TR>"""
	print contenu
        print "</table>"
        print "<p>"
        if deb>1 :
            print '<a href="stat-refus.php?deb='+str(2*deb-fin-1)+'">précédents</a>'
	    if len(lignes)>fin :
	        print ' | '
        if len(lignes)>fin :
            print '<a href="stat-refus.php?deb='+str(fin+1)+'">suivants</a>';
        print "</p>"
    else :
       print "<p>Aucun accès n'a été enregistré<br>&nbsp;</p>"

